
class clsGUI  {
   private:
   
   public:
      int         Xpos, Ypos, Width, Height, HeightText;
      color       clrPanel;
      int         previousMouseState, mlbDownX, mlbDownY, mlbDownXDistance, mlbDownYDistance;
      bool        movingState;
      string      Name;

		            clsGUI() : previousMouseState(0), mlbDownX(0), mlbDownY(0), mlbDownXDistance(0), mlbDownYDistance(0), movingState(false), Name(NULL) {};
      bool        CreatePanel(string name,int window,ENUM_BASE_CORNER corner, int x, int y,int Width,int height,color bg_color,color border_clr,int border_width=1, bool background=false);
      
      virtual void        Create_Controls(int x, int y) {Print("*** this is the GUI version");}
      void        OnEvent(int id, long lparam, double dparam, string sparam)  {
         //Verify the event that triggered the OnChartEvent was CHARTEVENT_MOUSE_MOVE because we only want to execute out code when that is the case
         if(id == CHARTEVENT_MOUSE_MOVE)           {
            int X = (int)lparam;
            int Y = (int)dparam;
            int MouseState = (int)sparam;
      
            string name = Name;
            int XDistance = (int)ObjectGetInteger(0, name, OBJPROP_XDISTANCE);
            int YDistance = (int)ObjectGetInteger(0, name, OBJPROP_YDISTANCE);
            int XSize = (int)ObjectGetInteger(0, name, OBJPROP_XSIZE);
            int YSize = (int)ObjectGetInteger(0, name, OBJPROP_YSIZE);
      
            if(previousMouseState == 0 && MouseState == 1) {   //Check if this was the MLB first click
               mlbDownX = X; //Set mlbDownX (Variable that stores the initial MLB X location) equal to the current X
               mlbDownY = Y; //Set mlbDownY (Variable that stores the initial MLB Y location) equal to the current Y
               mlbDownXDistance = XDistance; //Set mlbDownXDistance (Variable that stores the initial XDistance i.e. Width of the dashboard) equal to the current XDistance
               mlbDownYDistance = YDistance; //Set mlbDownYDistance (Variable that stores the initial YDistance i.e. Height of the dashboard) equal to the current YDistance
      
               if(X >= XDistance && X <= XDistance + XSize && Y >= YDistance && Y <= YDistance + YSize) //Check if the click was on the dashboard
                  movingState = true; //If yes the set movingState to True
            }
      
            if(movingState)   {     //if movingState is true, Update the Dashboard position
               ChartSetInteger(0, CHART_MOUSE_SCROLL, false);//Restrict Chart to be moved by Mouse
               Xpos=mlbDownXDistance + X - mlbDownX;
               Ypos=mlbDownYDistance + Y - mlbDownY;
               ObjectSetInteger(0, name, OBJPROP_XDISTANCE, Xpos);//Update XDistance to: mlbDownXDistance + (X - mlbDownX)
               ObjectSetInteger(0, name, OBJPROP_YDISTANCE, Ypos);//Update YDistance to: mlbDownYDistance + (Y - mlbDownY)
               Create_Controls(Xpos,Ypos);
               ChartRedraw(0); //Redraw Chart
            }
      
            if(MouseState == 0)  {     //Check if MLB is not pressed
               movingState = false;//set movingState again to false
               ChartSetInteger(0, CHART_MOUSE_SCROLL, true);//allow the cahrt to be moved again
            }
            previousMouseState = MouseState;//update the previousMouseState at the end so that we can use it next time and copare it with new value
           }
        }
        
};
//+------------------------------------------------------------------+  
 bool clsGUI::CreatePanel(string name,int window,ENUM_BASE_CORNER corner, int x, int y,int width,int height,color bg_color,color border_clr,int border_width=1, bool background=false) {
   Name = name;
   Xpos=x;
   Ypos=y;
   clrPanel=bg_color;
   Width=width;
   Height=height;
   if(Height < 100)  {
      HeightText=Height;
      Height=height+PairCount*20; 
   }
   if(!ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,window,0,0)){
      int ErrorCode=GetLastError();
      Print(__FUNCTION__,  ": failed to create a rectangle label, "+name+", Error code = ",ErrorCode);     //,": ",ErrorDescription(ErrorCode)); 
      return(false); 
   } 
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(0,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(0,name,OBJPROP_YSIZE,height);
   ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bg_color);
   ObjectSetInteger(0,name,OBJPROP_CORNER,corner);
   ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, true);
   ObjectSetInteger(0,name,OBJPROP_COLOR,border_clr);
   ObjectSetInteger(0,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
   ObjectSetInteger(0,name,OBJPROP_WIDTH,border_width);
   ObjectSetInteger(0,name,OBJPROP_CORNER,corner);
   ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSetInteger(0,name,OBJPROP_BACK,background);
   ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
   ObjectSetInteger(0,name,OBJPROP_SELECTED,0);
   ObjectSetInteger(0,name,OBJPROP_ZORDER,0);

   Create_Controls(x,y);
   return(true);
 }

//*******************************  Sample Panel
class clsSample: public clsGUI  {
   private:
   public:
            void  Create_Controls(int xpos, int ypos) {
            
                  SetText("Title","Sample Panel",0,xpos+250,ypos,clrWhite,10);
                  
                  //Place Header Test & controls here
                  
                  //below for use of multicurency EA
                  xpos-=210;   ypos+=15;
                  int xpossave=xpos+3, ypossave=ypos;;
                  for(int i=0;i<PairCount;i++)     {
                     xpos=xpossave;
                     ypos=ypossave;
                     string pair=Pairs[i].Pair;
                     string stringi=(string)i;
                     string suffix=" "+pair+": "+stringi; 
                     //Create_Panel("SamplePairsDetail"+suffix,0,0,xpos,ypos,Width-7,23,clrBlack,clrBlack,1);//C'61,61,61',1);
   
                      ypossave+=22;
               }
         }
};
